local mod = ...



-- Resource -------------------------------------------------------------------------------------
-- mod:registerAssetId("icons/Cider.png", "ICON_CIDER")

-- mod:register({
-- 	DataType = "RESOURCE",
-- 	Id = "RESOURCE_CIDER",
--     ResourceName = "RESOURCE_CIDER_NAME",
--     OrderId = 40,
-- 	Icon = "ICON_CIDER",
-- 	ResourceTypeList = { "TAVERN", "RESOURCE_FOOD" },
-- 	IsTradable = true,
-- 	ResourceLayoutType = "CRATES",
-- 	VillagerBuyingPrice = { Resource = "GOLD", Quantity = 16 },
-- 	DisplayInInventory = true
-- })



-- Assets -------------------------------------------------------------------------------------
mod:registerAssetId("models/CiderPress1.fbx/Prefab/PressPart", "PREFAB_CIDERPRESS")
mod:registerAssetId("models/CiderPress1.fbx/Prefab/ConstructionSteps", "PREFAB_CONSTR_CIDERPRESS")



-- Grounding  -------------------------------------------------------------------------------------
-- mod:registerPrefabComponent("models/CiderPress1.fbx/Prefab/PressPart/Barrel.001", {DataType = "COMP_GROUNDED"})



-- Building Asset Processor  -------------------------------------------------------------------------------------
mod:registerAssetProcessor("models/CiderPress1.fbx", { DataType = "BUILDING_ASSET_PROCESSOR" })



-- Job -------------------------------------------------------------------------------------

mod:register({
	DataType = "JOB",
	Id = "JOB_CIDERPRESS",
	JobName = "JOB_CIDERPRESS_NAME",
	JobDescription = "JOB_CIDERPRESS_DESC",
	IsLockedByDefault = false,
	DefaultBehavior = "BEHAVIOR_WORK",
    ProductionDelay = 30.0,
	AssetJobProgression = "DEFAULT_JOB_PROGRESSION",
	CharacterSetup = {
		DataType = "CHARACTER_SETUP",
        -- FemaleHatList = {
        --     "PREFAB_HAT_FARMER3",
        -- }, 
        -- MaleHatList = {
        --     "PREFAB_HAT_FARMER3",
        -- }, 
		WalkAnimation = "WALKING",
		IdleAnimation = "IDLE"
	}
})

mod:override({
    Id = "NEWCOMER",
    CompatibleJobList = {
        Action = "APPEND",
        "JOB_CIDERPRESS"
    }
})

mod:override({
    Id = "SERF",
    CompatibleJobList = {
        Action = "APPEND",
        "JOB_CIDERPRESS"
    }
})

mod:override({
    Id = "COMMONER",
    CompatibleJobList = {
        Action = "APPEND",
        "JOB_CIDERPRESS"
    }
})



-- Building Function: Cider Press -------------------------------------------------------------------------------------

mod:register({
    DataType = "BUILDING_FUNCTION_WORKPLACE",
    Id = "BUILDING_FUNCTION_CIDERPRESS",
    Name = "BUILDING_FUNCTION_CIDERPRESS_NAME",
    WorkerCapacity = 1,
    RelatedJob = { 
        Job = "JOB_CIDERPRESS", 
        Behavior = "BEHAVIOR_WORK"
    },
    InputInventoryCapacity = {
		{ Resource = "RESOURCE_FRUIT", Quantity = 25 },
	},
    ResourceListNeeded = {
		{ Resource = "RESOURCE_FRUIT", Quantity = 2 },
	},
	ResourceProduced = {{ Resource = "RESOURCE_CIDER", Quantity = 1 }}
})



-- Building: Cider Press -------------------------------------------------------------------------------------
mod:register({
	DataType = "BUILDING",
	Id = "BUILDING_CIDERPRESS",
	Name = "BUILDING_CIDERPRESS_NAME",
	Description = "BUILDING_CIDERPRESS_DESC",
    BuildingType = "GENERAL",
    AssetCoreBuildingPart = "BUILDING_PART_CIDERPRESS",
	VillagerRequired = { Status = "COMMONER", Quantity = 1 }
})



-- Building part: Cider Press -------------------------------------------------------------------------------------
mod:register({
	DataType = "BUILDING_PART",
    Id = "BUILDING_PART_CIDERPRESS",
    AssetBuildingFunction = "BUILDING_FUNCTION_CIDERPRESS",
    ConstructionVisual = "PREFAB_CONSTR_CIDERPRESS",
	BuildingZone = { 
        ZoneEntryList = {
            { 
                Polygon = polygon.createCircle( 3.35, {0.0, 0.0}, 24 ),
                Type = { DEFAULT = true, NAVIGABLE = true, GRASS_CLEAR = false } 
            },
            { 
                Polygon = polygon.createCircle( 2.5, {0.0, 0.0}, 24 ),
                Type = { DEFAULT = true, NAVIGABLE = true, GRASS_CLEAR = true } 
            },
		}
	},
    ConstructorData = {
            DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
            CoreObjectPrefab = "PREFAB_CIDERPRESS"
        }, 
	Cost = {
		BuildRightTaxes = {	{ Resource = "GOLD", Quantity = 15 } },
		UpkeepCost = { { Resource = "GOLD", Quantity = 20 } },
		RessourcesNeeded = {
            { Resource = "STONE", Quantity = 5 },
            { Resource = "WOOD", Quantity = 5 },
		}
    }
})
